#include <stdlib.h>
#include <string.h>
#include <token.h>
#include <tokeniser.h>
#include <dynarray.h>

token_t* tokenise_string(char* file_path, char* str) {
    const int str_len = strlen(str);
    loc_t loc = {0};
    loc.file = file_path;

    token_t* tokens = dynarray_create(token_t);

    for (int i = 0; i < str_len; i++) {
        switch (str[i]) {
        case (' '):
        case ('\t'):
        case ('\r'): {
            loc.col += 1;
            continue;
        }
        case ('\n'): {
            loc.col = 0;
            loc.line += 1;
            continue;
        }
        default: {
            // TODO: manage memory better
            // INFO: If you make an ident longer than 4kb i will murder you
            char* buf = malloc(1024 * 4);
            int buf_counter = 1;
            *buf = str[i];
            while (i < str_len && (str[i + 1] != ' ' || str[i + 1] != '\t' || str[i + 1] != '\n' || str[i + 1] != '\r')) {
                i += 1;
                buf[buf_counter++] = str[i];
            }
            buf = realloc(buf, strlen(buf) + 1);
            
        }
        }
    }
    return NULL;
}
